#set -x
md5sum -c fileinfo
vres=$?
if [ $vres -eq 1 ]; then
    echo "RUNME: FileList Check Failed!!!" >> /tmp/upgrade_result
    exit 3
fi
if [ ! -f cert.pem ]; then
  echo "RUNME: CANNOT FIND CERT!" >> /tmp/upgrade_result
  rm * -rf > /dev/null 2>&1
  exit 1
fi
if [ ! -f cert.pem.sig ]; then
  echo "RUNME: CANNOT FIND CERT SIG!" >> /tmp/upgrade_result
  rm * -rf > /dev/null 2>&1
  exit 2
fi
if [ -e /etc/hiveon-pub.pem ]; then
  openssl dgst -sha256 -verify /etc/hiveon-pub.pem -signature  cert.pem.sig  cert.pem >/dev/null  2>&1 
  res=$?
  if [ $res -ne 0 ]; then
    echo "RUNME: CANNOT VERIFY CERT !" >> /tmp/upgrade_result
    rm * -rf > /dev/null 2>&1
    exit 3
  fi
fi
if [ ! -f fw.tar.gz.sig ]; then
  echo "RUNME: CANNOT FIND FW SIGNATURE!" >> /tmp/upgrade_result
  rm * -rf > /dev/null 2>&1
  exit 4
fi
openssl dgst -sha256 -verify cert.pem -signature  fw.tar.gz.sig  fw.tar.gz >/dev/null  2>&1 
res=$?
if [ $res -ne 0 ]; then
  echo "RUNME: CANNOT VERIFY FW !" >> /tmp/upgrade_result
  rm * -rf > /dev/null 2>&1
  exit 5
fi

if ! [ -d /tmp/mem/ ]; then
    mkdir /tmp/mem
    mount -t tmpfs tmpfs /tmp/mem
else
    rm -r -f /tmp/mem/*
fi

if [ -s "FARM_HASH" ]; then
    hash=$(cat FARM_HASH | head -n 1 | tr -dc '[:alnum:]\n\r')
    if [ $(echo $hash | wc -c) -ne 41 ]; then
        echo "Invalid FARM_HASH" >> /tmp/upgrade_result
    else
        cat FARM_HASH | head -n 1 | tr -dc '[:alnum:]\n\r' > /config/FARM_HASH
    fi
fi

if [ -s "HIVE_HOST_URL" ]; then
    cat HIVE_HOST_URL | tr -d ';|"' > /config/HIVE_HOST_URL
fi

[ -e "/nvdata/latest.tar.gz" ] && rm -rf /nvdata/latest.tar.gz > /dev/null 2>&1

mkdir /tmp/mem/fw
tar zxvf fw.tar.gz -C /tmp/mem/fw > /dev/null 2>&1
rm fw.tar.gz
cd /tmp/mem/fw
sh runme.sh
sync >/dev/null 2>&1
